#include "io.h"
#include "lcd.h"
#include <avr/pgmspace.h>
#include <stdio.h>
#define F_CPU 8000000
#include <util/delay.h>

void setpixel(unsigned char c) {
	c>>=4;
	sendByteLcd(c|(c<<4));
	sendByteLcd(c);
}

int main(void) {
	char x,y,b;
	char oldb;
	char err;
	short pal[]={0xfff, 0xf00, 0x0f0, 0x00f, 0xff0, 0xf0f, 0x0ff, 0x000};
	int col=0;
	
	initIo();
	initLcd();
	printf("Init.");
	_delay_ms(1000);
	//Mouse init stuff. Check out the ps2-mouse documentation for more info.
	ps2Send(0xff); //Reset mouse
	err=0;
	printf(".");
	if (ps2Recv()!=0xFA) err=1;
	if (ps2Recv()!=0xAA) err=1;
	if (ps2Recv()!=0x00) err=1;
	if (err) printf("Err: i");
	printf(".");
	ps2Send(0xf6); //Set Defaults: default dpi etc; go to stream mode
	printf(".");
	err=0;
	if (ps2Recv()!=0xFA) err=1;
	printf(".");
	ps2Send(0xf4); //Enable data reporting; the mouse will tell me when it moves
	printf(".");
	err=0;
	if (ps2Recv()!=0xFA) err=1;
	printf(".");
	if (err) printf("Err: d");
	ps2Send(0xf3); //Set sample rate to 200
	ps2Send(200); 
	printf(".");
	err=0;
	if (ps2Recv()!=0xFA) err=1;
	ps2Send(200); 
	if (ps2Recv()!=0xFA) err=1;
	printf(".");
	if (err) printf("Err: d");
	printf("Inited.\n");
	
	while(1) {
		//Receive buttons, x displacement, y displacement
		b=ps2Recv();
		x+=ps2Recv();
		y-=ps2Recv();
//		printf("%02x %03hhi,%03hhi\n",b,x,y);
		//Clip current position to max size of LCD
		if (x<0) x=0;
		if (y<0) y=0;
		if (x>104) x=104;
		if (y>104) y=104;
		if (b&1) { //Button one is pressed
			windowLcd(x,y,x,y); //Draw just one pixel at (x,y)
			//Send the pixel
			sendDataLcd();
			sendByteLcd(pal[col]>>8);
			sendByteLcd(pal[col]&0xff);
			endCmdLcd();
		}
		if ((b&2) && (!(oldb&2))) { //Second button pressed, was released before
			//next color
			col++;
			if (col>9) col=0;
		}
		if ((b&3)==3) { //Both buttons pressed
			clearLcd();
		}
		oldb=b;
	}
}

