#define F_CPU 8000000
#include <avr/io.h>
#include <util/delay.h>
#include "io.h"

#define LCD_CS	PB0
#define LCD_RESET PD7
#define LCD_RS PD6
#define LCD_CLK PD5
#define LCD_DAT PB7
#define CAM_CLK PC0
#define CAM_DAT PC1

void initIo() {
	DDRB=(1<<LCD_CS)|(1<<LCD_DAT);
	DDRD=(1<<LCD_RESET)|(1<<LCD_RS)|(1<<LCD_CLK);
	DDRC=(1<<CAM_DAT)|(1<<CAM_CLK);
}

void sendCam(unsigned char addr, unsigned char data) {
	short p;
	char x;
	p=(addr<<8)|data;
	p|=0x8000;
	for (x=0; x<16; x++) {
		if (p&0x8000) {
			PORTC|=(1<<CAM_DAT);
		} else {
			PORTC&=~(1<<CAM_DAT);
		}
		PORTC&=~(1<<CAM_CLK);
		p<<=1;
		PORTC|=(1<<CAM_CLK);
	}
	_delay_us(100);
}

unsigned char recvCam(unsigned char addr) {
	unsigned char x, ret;
	addr&=0x7f;
	for (x=0; x<8; x++) {
		if (addr&0x80) {
			PORTC|=(1<<CAM_DAT);
		} else {
			PORTC&=~(1<<CAM_DAT);
		}
		PORTC&=~(1<<CAM_CLK);
		addr<<=1;
		PORTC|=(1<<CAM_CLK);
	}
	DDRC&=~(1<<CAM_DAT);
	PORTC|=(1<<CAM_DAT);
	for (x=0; x<8; x++) {
		ret<<=1;
		PORTC&=~(1<<CAM_CLK);
		PORTC|=(1<<CAM_CLK);
		if (PINC&(1<<CAM_DAT)) ret|=1;
	}
	DDRC|=(1<<CAM_DAT);
	_delay_us(100);
	return ret;
}

void resetLcd() {
	PORTB|=(1<<LCD_CS);
	PORTD&=~(1<<LCD_RESET);
	_delay_ms(10);
	PORTD|=(1<<LCD_RESET);
}

void sendCmdLcd(void) {
	PORTD|=(1<<LCD_RS);
	PORTB&=~(1<<LCD_CS);
}

void sendDataLcd(void) {
	PORTD&=~(1<<LCD_RS);
	PORTB&=~(1<<LCD_CS);
}

void sendByteLcd(char byte) {
	char x;
	for (x=0; x<8; x++) {
		if (byte&0x80) {
			PORTB|=(1<<LCD_DAT);
		} else {
			PORTB&=~(1<<LCD_DAT);
		}
		PORTD|=(1<<LCD_CLK);
		byte<<=1;
		PORTD&=~(1<<LCD_CLK);
	}
}

void endCmdLcd() {
	PORTB|=(1<<LCD_CS);		
}
